#include <stdlib.mqh>
//+------------------------------------------------------------------+
//|                                      DMTrendLines&PricesDown.mq4 |
//|                                                                  |
//|                                                                  |
//|                                        Converted by Mql2Mq4 v0.7 |
//|                                            http://yousky.free.fr |
//|                                    Copyright  2006, Yousky Soft |
//+------------------------------------------------------------------+

#property copyright " Copyright  2003, Company"
#property link      " http://www.company.com/"

#property indicator_chart_window
#property indicator_color1 Red
#property indicator_buffers 1

//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;
double ExtHistoBuffer[];

void SetLoopCount(int loops)
{
}

void SetIndexValue(int shift, double value)
{
  ExtHistoBuffer[shift] = value;
}

bool MoveObject(string name, int type, datetime Atime, double Aprice, datetime Atime2 = 0, double Aprice2 = 0, color Acolor = CLR_NONE, int Aweight = 0, int Astyle = 0)
{
    if (ObjectFind(name) != -1)
    {
      int OType = ObjectType(name);

      if ((OType == OBJ_VLINE) ||
         (OType == OBJ_HLINE) ||
         (OType == OBJ_TRENDBYANGLE) ||
         (OType == OBJ_TEXT) ||
         (OType == OBJ_ARROW) ||
         (OType == OBJ_LABEL))
      {
        return(ObjectMove(name, 0, Atime, Aprice));
      }

      if ((OType == OBJ_GANNLINE) ||
         (OType == OBJ_GANNFAN) ||
         (OType == OBJ_GANNGRID) ||
         (OType == OBJ_FIBO) ||
         (OType == OBJ_FIBOTIMES) ||
         (OType == OBJ_FIBOFAN) ||
         (OType == OBJ_FIBOARC) ||
         (OType == OBJ_RECTANGLE) ||
         (OType == OBJ_ELLIPSE) ||
         (OType == OBJ_CYCLES) ||
         (OType == OBJ_TREND) ||
         (OType == OBJ_STDDEVCHANNEL) ||
         (OType == OBJ_REGRESSION))
      {
        return(ObjectMove(name, 0, Atime, Aprice) && ObjectMove(name, 1, Atime2, Aprice2));
      }

/*
          OBJ_CHANNEL,
          OBJ_EXPANSION,
          OBJ_FIBOCHANNEL,
          OBJ_TRIANGLE,
          OBJ_PITCHFORK
*/
    }
    else
    {
      return(ObjectCreate(name, type, 0, Atime, Aprice, Atime2, Aprice2, 0, 0) && ObjectSet(name, OBJPROP_COLOR, Acolor));
    }
}

//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
{
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID);
   SetIndexBuffer(0, ExtHistoBuffer);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID);
   return(0);
}
int start()
{
//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
int shift = 0;
double KDown = 0;
double BDown = 0;
double MaxPrice = 0;
double TargetPriceDown = 0;
int n = 0;
double TrendPriceDown[2,1];
double Minimum[2,1];
double TimeofMinimum[2,1];
double shiftofMinimum[2,1];

/*[[
	Name := DMTrendLines&PricesDown
	Author := Copyright  2003, Company
	Link := http://www.company.com/
	Separate Window := No
	First Color := Red
	First Draw Type := Line
	First Symbol := 217
	Use Second Data := No
	Second Color := Red
	Second Draw Type := Line
	Second Symbol := 218
]]*/






SetLoopCount(0);
// loop from first bar to current bar (with shift=0)
for(shift =Bars - 1;shift >=1 ;shift --){ 
{
    TrendPriceDown[1,1] = TrendPriceDown[2,1];
	
	TrendPriceDown[2,1] = KDown*(shift) + BDown;
    SetIndexValue(shift, TrendPriceDown[2,1]);
	
    if( Low[shift] < Low[shift - 1] &&  Low[shift] <= Low[shift + 1]      //  - , 
	) {Minimum[1,1] = Minimum[2,1]; TimeofMinimum[1,1] = TimeofMinimum[2,1];                                 //  
	      shiftofMinimum[1,1] = shiftofMinimum[2,1]; 
	      shiftofMinimum[2,1] = shift;                               
	      Minimum[2,1] = Low[shift]; 
	      TimeofMinimum[2,1] = Time[shift];                            
	          
          KDown = (Minimum[2,1]-Minimum[1,1])/(shiftofMinimum[2,1]-shiftofMinimum[1,1]);                        //     
          BDown = Minimum[1,1] - KDown*shiftofMinimum[1,1]; 
          
          TrendPriceDown[2,1] = KDown*(shift) + BDown; 
                   
          if( Minimum[1,1] <= Minimum[2,1]                                              //  , 
          ) {for(n =shiftofMinimum[1,1];n >=shiftofMinimum[2,1] ;n --){                       //    , 
                   {                                                          //   
                     TrendPriceDown[2,1] = KDown*(n) + BDown; 
                     SetIndexValue(n, TrendPriceDown[2,1]);                                
                   }
                   } 
                                                                                                                 //  
                MoveObject("DownTrend", OBJ_TREND, TimeofMinimum[1,1], Minimum[1,1], TimeofMinimum[2,1], Minimum[2,1], Red, 1, STYLE_SOLID);  //
               }
         }
    
	if( Close[shift] < TrendPriceDown[2,1] && Close[shift+1] >= TrendPriceDown[1,1]   //   ,
	&& TrendPriceDown[1,1] <= TrendPriceDown[2,1]                                    //  .
	) {MaxPrice = High[Highest(NULL, 0, MODE_HIGH, shiftofMinimum[1,1], shiftofMinimum[1,1] - shift)];                                       //  
	      TargetPriceDown = TrendPriceDown[2,1] - (MaxPrice - TrendPriceDown[2,1]);
	      
	      MoveObject("TargetPriceDown"+MathMod(shift,1), OBJ_HLINE, TimeofMinimum[1,1], TargetPriceDown, TimeofMinimum[2,1], TargetPriceDown, Red, 1, STYLE_DOT);
	          
         }

}
}   return(0);
}